<?php

namespace EventPortal\Domain\Admin\Handlers;

use Closure;
use EventPortal\Domain\Admin\Models\Admin;
use EventPortal\Domain\Form\Payload;
use EventPortal\Domain\User\Events\UserCreated;
use EventPortal\Domain\Util\Notification\Facades\Notification;

class CreateAdmin
{
    /**
     * @return mixed
     */
    public function __invoke(Payload $payload, Closure $next)
    {
        $admin = Admin::create($payload->getInput());

        $admin->user_id = $payload->getModel()->id;
        $admin->save();

        event(new UserCreated($payload->getModel()));

        $payload->addContext('admin', $admin);

        Notification::make('admin.created')
            ->to($admin->user)
            ->send();

        return $next($payload);
    }
}
